//+------------------------------------------------------------------+
//|                                alb - TriangularMA price zone.mq4 |
//|                                                           mladen |
//|                                                                  |
//| original idea and first implementation                           |
//| for this indicator by mrtools                                    |
//+------------------------------------------------------------------+
#property copyright "mrtools & mladen"
#property link      "mrtools & mladen"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

//
//
//
//
//

extern int    swingCount  = 5;
extern int    rangePeriod = 5;
extern int    Price       = PRICE_MEDIAN;
extern double speed       = 1.0;
extern double Deviation   = 1.8;

//
//
//
//
//

double buffer1[];
double buffer2[];
double swingBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,swingBuffer);
   return(0);
}
int deinit() { return(0); }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,n,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars+4*rangePeriod);

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
      for (k=i,n=0; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
         int HalfLength = MathMax(MathRound((k-i)/swingCount/speed),1);

         //
         //
         //
         //
         //

         double sum   = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double sumw  = (HalfLength+1);
            for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
            {
               sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
               sumw += k;
               if (j<=i)
               {
                  sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
                  sumw += k;
               }
            }
         double tma    = sum/sumw;
         double range  = CalculateRange(rangePeriod,i);

         //
         //
         //
         //
         //
         
      buffer1[i] = tma+Deviation*range;
      buffer2[i] = tma-Deviation*range;
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double CalculateRange(int HalfLength,int i)
{
   int j,k;
   double lsum   = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i);
   double hsum   = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i);
   double sumw   = (HalfLength+1);
   
   //
   //
   //
   //
   //
      
   for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
   {
      lsum += k*iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i+j);
      hsum += k*iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+j);
      sumw += k;

      if (j<=i)
      {
         lsum  += k*iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,i-j);
         hsum  += k*iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i-j);
         sumw += k;
      }
   }
   return (hsum/sumw - lsum/sumw);
}